unit DD75u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDD75f1 = class(TForm)
    laID: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Memo1: TMemo;
    buSave: TButton;
    buQuit: TButton;
    buRemove: TButton;
    SaveDialog1: TSaveDialog;
    laWarn: TLabel;
    laInfo: TLabel;
    procedure buQuitClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure buRemoveClick(Sender: TObject);
    procedure buSaveClick(Sender: TObject);
    procedure Edit6KeyPress(Sender: TObject; var Key: Char);
    procedure EditSeveralClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);

  private
    { Private declarations }
    bE1,bE2,bE3,bE4,bE5,bE6:byte;
    bSE1,bSE2,bSE3,bSE4,bSE5,bSE6:byte;
    procedure FillField5;
  public
    { Public declarations }
  end;

var
  DD75f1: TDD75f1;

implementation

{$R *.DFM}

procedure TDD75f1.buQuitClick(Sender: TObject);
begin
close;
end;

procedure TDD75f1.FormCreate(Sender: TObject);
begin
bSE1:=2;
bSE2:=3;
bSE3:=2;
bSE4:=1;
bSE5:=3;//See FillField5 for some hard coding.
bSE6:=1;
Edit1Change(self);
Edit2Change(self);
Edit3Change(self);
Edit4Change(self);
Edit5Change(self);
end;

procedure TDD75f1.Edit1Change(Sender: TObject);
begin
if length(Edit1.text)=bSE1 then begin
    Edit1.color:=$0000FF00;
    bE1:=0;
    Edit6.text:='';
    end//no ; here
  else begin
    Edit1.color:=$00aaaaff;
    bE1:=1;
    end;
end;

procedure TDD75f1.Edit2Change(Sender: TObject);
begin
if length(Edit2.text)=bSE2 then begin
    Edit2.color:=$0000FF00;
    bE2:=0;
    Edit6.text:='';
    end//no ; here
  else begin
    Edit2.color:=$00aaaaff;
    bE2:=1;
    end;
end;

procedure TDD75f1.Edit3Change(Sender: TObject);
begin
if length(Edit3.text)=bSE3 then begin
    Edit3.color:=$0000FF00;
    bE3:=0;
    Edit6.text:='';
    end//no ; here
  else begin
    Edit3.color:=$00aaaaff;
    bE3:=1;
    end;
end;

procedure TDD75f1.Edit4Change(Sender: TObject);
begin
if length(Edit4.text)=bSE4 then begin
    Edit4.color:=$0000FF00;
    bE4:=0;
    Edit6.text:='';
    end//no ; here
  else begin
    Edit4.color:=$00aaaaff;
    bE4:=1;
    end;
end;

procedure TDD75f1.Edit5Change(Sender: TObject);
begin
if length(Edit5.text)=bSE5 then begin
    Edit5.color:=$0000FF00;
    bE5:=0;
    Edit6.text:='';
    end//no ; here
  else begin
    Edit5.color:=$00aaaaff;
    bE5:=1;
    end;
end;

procedure TDD75f1.Edit6Change(Sender: TObject);
var sTmp:string;
begin
if length(Edit6.text)=1 then bE6:=0 else bE6:=1;
if bE1+bE2+bE3+bE4+bE5+bE6=0 then begin // only add a line if all the fields are
     //of the correct length.
 sTmp:=Edit1.text+Edit2.text+Edit3.text+Edit4.text+Edit5.text+Edit6.text;
 memo1.Lines.add(sTmp);
 buSave.enabled:=true;
 Edit6.text:='';
 FillField5;
 end;//of if
end;

procedure TDD75f1.buRemoveClick(Sender: TObject);
begin
if memo1.lines.count>0 then
     memo1.lines.delete(memo1.lines.count-1);
end;

procedure TDD75f1.buSaveClick(Sender: TObject);
begin
if SaveDialog1.Execute then begin
    memo1.Lines.SaveToFile(SaveDialog1.FileName);
    buSave.enabled:=false;
    end;
end;

procedure TDD75f1.FillField5;
var iValue,iCode:integer;
    sTmp:string;
begin
val(edit5.text, iValue, iCode);
if iCode=0 then begin
   iValue:=iValue+1;
   sTmp:=inttostr(iValue);
   while length(sTmp)<3 do sTmp:='0'+sTmp;
   if length(sTmp)>3 then iCode:=1;//flag error arising from incrementing 999
   Edit5.text:=sTmp;
   end;
if iCode<>0 then //Note that iCode may have started as
   //0 after the call to val(... , but been changed to
   //1 in the block under "if iCode=0 then...
   Edit5.text:='';//Clear it if what was in it before
   //wasn't a number, or if it was 999, in which case
   //the next number is too big to hold in 3 characters,
   //the limit imposed by the program's requirements.
//Edit5.text:='yyy';
end;

procedure TDD75f1.Edit6KeyPress(Sender: TObject; var Key: Char);
begin
if pos(Key,'abcde12345')=0 then begin
    Key:=chr(0);
    laWarn.caption:='Only a,b,c,d or e allowed';
    end//no ; here
  else
    if key='1'then key:='a';
    if key='2'then key:='b';
    if key='3'then key:='c';
    if key='4'then key:='d';
    if key='5'then key:='e';
    laWarn.caption:='';
end;

procedure TDD75f1.EditSeveralClick(Sender: TObject);
begin
if sender=Edit1 then Edit1.selectall;
if sender=Edit2 then Edit2.selectall;
if sender=Edit3 then Edit3.selectall;
if sender=Edit4 then Edit4.selectall;
if sender=Edit5 then Edit5.selectall;
//I can't believe this needs to be done so crudely
//If you can tell me a better way, please do??!
//   ("sender.selectall;" isn't allowed.)
end;

procedure TDD75f1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var wTmp:word;
begin
CanClose:=true;
if buSave.enabled=true then begin
  //see accompanying tutorial...
  wTmp:=MessageDlgPos('Performance history has changed.'+chr(10)+
     'Do you want to save the newer data?',
     mtConfirmation, //type of message box
     mbYesNoCancel, //Buttons / return values
     0, //Help context. (Not used here)
     200, 200);  //X/Y of message top left. Screen coords.
  //end "see tutorial"
  if wTmp=mrYes then buSaveClick(self);//Save the data, and leave CanClose true.
  //if wTmp=mrNo then ... do nothing. CanClose will remain true, we close without saving
  if wTmp=mrCancel then CanClose:=false;//This will block attempt to close program
  end;
end;

end.
